{   obcc, a small oberoncompiler for the C16x-family
      based on Oberon-0 by N. Wirth

    Copyright 2011 Guido B. (user "guido-b" at http://www.mikrocontroller.net)

    Sprocs.pas, systemprocedures, is part of obcc.
    
    obcc is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    obcc is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with obcc.  If not, see <http://www.gnu.org/licenses/>.                }

UNIT Sprocs;

interface
uses obcs, obcg;

CONST
	{FP = 0; FSP = 1;}  FSP = 0; FP = 1; g_PC = 16;  (*reserved registers*)
TYPE 
     stringp = ^stringt;

     stringt = RECORD
      nr: INTEGER;
      inh: string[idlen];
      next: stringp;
    END;

    Tsfrreg = Record
      reg: Integer;
      adr: LongInt;
    End;
    
VAR
    
    vartop: LONGINT;
    i, nextstring: INTEGER;
    tnextreg, tlastreg: INTEGER;
    stringl: stringp;
    cl: LongInt; {Codelaenge }    

FUNCTION hexword(i:LONGINT):STRING;
FUNCTION hexbyte(i:Byte):STRING;
Function Fsfr(name: String): Tsfrreg;
PROCEDURE start_Sproc;
PROCEDURE end_Sprocs;
PROCEDURE Write_string(nr: INTEGER);
PROCEDURE Put_writeln;

PROCEDURE Put_Strings;
PROCEDURE Put_Write;

implementation

	FUNCTION hexword(i:LONGINT):STRING;
	  var temp: INTEGER; 
	BEGIN hexword := '0';
	  IF i > $FFFF THEN BEGIN
	    temp := i div $10000; temp := temp div 16;
	    if temp < 10 then hexword := hexword + chr(temp + 48)
	    else hexword := hexword + chr(temp + 55);
	    temp := i div $10000; temp := temp mod 16;
	    if temp < 10 then hexword := hexword + chr(temp + 48)
	    else hexword := hexword + chr(temp + 55);
	    i := i MOD $10000;
	  END;
	  temp := i div (256); temp := temp div 16;
	  if temp < 10 then hexword := hexword + chr(temp + 48)
	  else hexword := hexword + chr(temp + 55);
	  temp := i div 256; temp := temp mod 16;
	  if temp < 10 then hexword := hexword + chr(temp + 48)
	  else hexword := hexword + chr(temp + 55);
	  temp := i mod 256; temp := temp div 16;
	  if temp < 10 then hexword := hexword + chr(temp + 48)
	  else hexword := hexword + chr(temp + 55);
	  temp := i mod 256; temp := temp mod 16;
	  if temp < 10 then hexword := hexword + chr(temp + 48)
	  else hexword := hexword + chr(temp + 55);
	  hexword := hexword + 'h';
	END;
	
	FUNCTION hexbyte(i:Byte):STRING;
	Var temp: Byte;
	Begin hexbyte := '0';
	  temp := i Div 16;
	  If temp < 10 Then hexbyte := hexbyte + chr(temp + 48)
	  Else hexbyte := hexbyte + chr(temp + 55);
	  temp := i Mod 16;
	  If temp < 10 Then hexbyte := hexbyte + chr(temp + 48)
	  Else hexbyte := hexbyte + chr(temp + 55);
	  hexbyte := hexbyte + 'h';
	End;
	
	Function Fsfr(name: String): Tsfrreg;
	Var f: Psfr; adr: Longint;
	Begin f := Listsfr;
	  While (f^.next <> Nil) And (f^.name <> name) Do
	    f := f^.next;
	  If f^.name = Name Then Begin
	    adr := f^.adr; Fsfr.adr := adr;
	    IF (adr < $FFFF) And (adr >= $FE00) Then
	      Fsfr.reg := (adr - $FE00) Div 2
	    Else If (adr < $F1FF) And (adr >= $F000) Then
	      Fsfr.reg := (adr - $F000) Div 2
	    Else Fsfr.reg := $100;
	  End
	  Else Begin
	    Fsfr.adr := -1; Fsfr.reg := -1;
	  End;
	End;

	PROCEDURE start_Sproc;
	Var p: Tsfrreg;
	BEGIN p := Fsfr('PSW');
	  writeln(Taus, chr(9), 'push', chr(9), HexWord(p.adr));
	  writeln(Taus, chr(9), 'push', chr(9), 'R0');
	  writeln(Taus, chr(9), 'bclr', chr(9), HexWord(p.adr), '.11');
	  writeln(Taus, chr(9), 'add', chr(9), HexWord(CPadr),', #32');
	  writeln(Taus, chr(9), 'nop');
	  writeln(Taus, chr(9), 'pop', chr(9), 'R0');
	  INC(cl, 10);
	END;

	PROCEDURE end_Sprocs;
	Var p: Tsfrreg;
	BEGIN p := Fsfr('PSW');
	  writeln(Taus, chr(9), 'sub', chr(9), HexWord(CPadr), ', #32');
	  //writeln(Taus, chr(9), 'nop');
	  writeln(Taus, chr(9), 'pop', chr(9), HexWord(p.adr));
	  INC(cl, 6);
	END;
	
	PROCEDURE Write_string(nr: INTEGER);
	  VAR s: string;
	BEGIN str(nr,s);
	  writeln(Taus, chr(9), 'mov', chr(9), 'R1, #String', modname, s);
	  writeln(Taus, chr(9), 'call', chr(9), 'writestr');
	  INC(cl, 8);
	END;
	
	PROCEDURE Put_writeln;
	Var p: Tsfrreg;
	BEGIN p := Fsfr('PSW');
	  writeln(Taus, chr(9), 'push', chr(9), HexWord(p.adr));
	  writeln(Taus, chr(9), 'bclr', chr(9), HexWord(p.adr), '.11');
	  writeln(Taus, chr(9), 'call', chr(9), 'writeln');
	  writeln(Taus, chr(9), 'pop', chr(9), HexWord(p.adr));
	  INC(cl, 10);
	END;		
	
	PROCEDURE Put_Strings;
	  VAR j: INTEGER; s: string;
	BEGIN 
	  WHILE stringl <> NIL DO BEGIN
	    str(stringl^.nr, s); 
	    writeln(Taus, 'String', modname, s, ':');
	    s := Stringl^.inh; j := 1;
	    write(Taus, chr(9), 'DB', chr(9), '"');
	    WHILE s[j] <> chr(0) DO BEGIN
	      write(Taus, s[j]); j := j + 1;
	    END;
	    write(Taus, '"');
	    WHILE j <= length(s) DO BEGIN
	      write(Taus, ', 0'); j := j + 1;
	    END;
	    Writeln(Taus);
	    cl := cl + j - 1;
	    stringl := stringl^.next;
	  END;
	END;
	
	PROCEDURE Put_Write;
	VAR AscFlag, AscReg: String; p: Tsfrreg;
	BEGIN Str(AscPort, AscReg); 
	  AscReg := 'S' + AscReg + 'TBUF';
	  p := Fsfr(Ascreg); AscReg := HexWord(p.adr);
	  Str(AscPort, AscFlag);
	  AscFlag := 'S' + AscFlag + 'TIC';
	  p := Fsfr(AscFlag); AscFlag := HexWord(p.adr) + '.7';
	  {writesign, Minuszeichen }
	  writeln(Taus, 'writesign:');
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #1');
	  writeln(Taus, chr(9), 'mov', chr(9), AscReg, ', #45');
	  writeln(Taus, 'writesign_1:');
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #1');
	  Writeln(Taus, chr(9), 'jnb', chr(9), AscFlag, ', writesign_1');
	  writeln(Taus, chr(9), 'bclr', chr(9), AscFlag);
	  writeln(Taus, chr(9), 'ret', chr(9), chr(9), chr(9), '; writesign');
	  { WriteStr }
	  writeln(Taus, 'writestr:');
	  { TODO: Der String liegt im Codesegment, ich nehme einfach Segment 0 an.
		  Dies muss noch auf das aktuelle Codesegment angepasst werden! }
	  writeln(Taus, chr(9), 'exts', chr(9), '#0, #1');
	  
	  writeln(Taus, chr(9), 'movb', chr(9), 'RL2, [R1+]');
	  writeln(Taus, chr(9), 'jmp', chr(9), 'Z, writestr_e');
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #1');
	  writeln(Taus, chr(9), 'movbz', chr(9), AscReg, ', RL2');
	  writeln(Taus, 'writestr_1:');
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #1');
	  Writeln(Taus, chr(9), 'jnb', chr(9), AscFlag, ', writestr_1');
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #1');
	  writeln(Taus, chr(9), 'bclr', chr(9), AscFlag);
	  writeln(Taus, chr(9), 'jmp', chr(9), 'writestr');
	  writeln(Taus, 'writestr_e:');
	  writeln(Taus, chr(9), 'ret', chr(9), chr(9), chr(9), '; writestr');
	  { WriteLN }
	  writeln(Taus, 'writeln:');
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #1');
	  writeln(Taus, chr(9), 'mov', chr(9),  AscReg, ', #13');
	  writeln(Taus, 'writeln_1:');
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #1');
	  Writeln(Taus, chr(9), 'jnb', chr(9), AscFlag, ', writeln_1');
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #2');
	  writeln(Taus, chr(9), 'bclr', chr(9), AscFlag);
	  writeln(Taus, chr(9), 'mov', chr(9), AscReg, ', #10');
	  writeln(Taus, 'writeln_2:');
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #2');
	  Writeln(Taus, chr(9), 'jnb', chr(9), AscFlag, ', writeln_2');
	  writeln(Taus, chr(9), 'bclr', chr(9), AscFlag);
	  writeln(Taus, chr(9), 'ret', chr(9), chr(9), chr(9), '; writeln');
	  { writeval }
	  writeln(Taus, 'writeval:');
	  writeln(Taus, chr(9), 'mov', chr(9), 'R2, #', hexword(vartop MOD $10000));
	  writeln(Taus, chr(9), 'add', chr(9), 'R2, #10');
	  writeln(Taus, chr(9), 'mov', chr(9), 'R3, R2');
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #1');
	  p := Fsfr('MDL');
	  writeln(Taus, chr(9), 'mov', chr(9), HexWord(p.adr), ', R1');
	  writeln(Taus, 'writev_1:');
	  writeln(Taus, chr(9), 'mov', chr(9), 'R4, #10');
	  writeln(Taus, chr(9), 'divu', chr(9), 'R4');
	  writeln(Taus, chr(9), 'jmp', chr(9), 'Z, writev_2');
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #1');
	  p := Fsfr('MDH');
	  writeln(taus, chr(9), 'mov', chr(9), 'R5, ', HexWord(p.adr));
	  writeln(Taus, chr(9), 'add', chr(9), 'R5, #48');
	  writeln(Taus, chr(9), 'mov', chr(9), '[-R2], R5');
	  writeln(Taus, chr(9), 'jmp', chr(9), 'writev_1');
	  writeln(Taus, 'writev_2:');
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #1');
	  p := Fsfr('MDH');
	  writeln(taus, chr(9), 'mov', chr(9), 'R5, ', HexWord(p.adr));
	  writeln(Taus, chr(9), 'add', chr(9), 'R5, #48');
	  writeln(Taus, chr(9), 'mov', chr(9), '[-R2], R5');
	  writeln(Taus, 'writev_3:');
	  writeln(Taus, chr(9), 'mov', chr(9), 'R5, [R2+]');
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #1');
	  writeln(Taus, chr(9), 'mov', chr(9), AscReg, ', R5');
	  writeln(Taus, 'writev_4:');
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #1');
	  Writeln(Taus, chr(9), 'jnb', chr(9), AscFlag, ', writev_4');
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #1');
	  writeln(Taus, chr(9), 'bclr', chr(9), AscFlag);
	  writeln(Taus, chr(9), 'cmp', chr(9), 'R2, R3');
	  writeln(Taus, chr(9), 'jmp', chr(9), 'EQ, writev_e');
	  writeln(Taus, chr(9), 'jmp', chr(9), 'writev_3');
	  writeln(Taus, 'writev_e:');
	  writeln(Taus, chr(9), 'ret', chr(9), chr(9), chr(9), '; writeval');
	  { writehex }
	  writeln(Taus, 'writehex:');
	  writeln(Taus, chr(9), 'mov', chr(9), 'R2, #', hexword(vartop MOD $10000));
	  writeln(Taus, chr(9), 'add', chr(9), 'R2, #8');
	  writeln(Taus, chr(9), 'mov', chr(9), 'R3, #4');
	  writeln(Taus, 'writeh_1:');
	  writeln(Taus, chr(9), 'mov', chr(9), 'R4, R1');
	  writeln(Taus, chr(9), 'and', chr(9), 'R4, #15');
	  writeln(Taus, chr(9), 'add', chr(9), 'R4, #48');
	  writeln(Taus, chr(9), 'cmp', chr(9), 'R4, #57');
	  writeln(Taus, chr(9), 'jmp', chr(9), 'ULE, writeh_2');
	  writeln(Taus, chr(9), 'add', chr(9), 'R4, #7');
	  writeln(Taus, 'writeh_2:');
	  writeln(Taus, chr(9), 'mov', chr(9), '[-R2], R4');
	  writeln(Taus, chr(9), 'shr', chr(9), 'R1, #4');
	  writeln(Taus, chr(9), 'sub', chr(9), 'R3, #1');
	  writeln(Taus, chr(9), 'jmp', chr(9), 'NZ, writeh_1');
	  writeln(Taus, chr(9), 'mov', chr(9), 'R3, #4');
	  writeln(Taus, 'writeh_3:');
	  writeln(Taus, chr(9), 'mov', chr(9), 'R4, [R2+]');
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #1');
	  writeln(Taus, chr(9), 'mov', chr(9), AscReg, ', R4');
	  writeln(Taus, 'writeh_4:');
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #1');
	  Writeln(Taus, chr(9), 'jnb', chr(9), AscFlag, ', writeh_4');
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #1');
	  writeln(Taus, chr(9), 'bclr', chr(9), AscFlag);
	  writeln(Taus, chr(9), 'sub', chr(9), 'R3, #1');
	  writeln(Taus, chr(9), 'jmp', chr(9), 'NZ, writeh_3');
	  writeln(Taus, chr(9), 'ret', chr(9), chr(9), chr(9), '; writehex');
	  { writechar }
	  writeln(Taus, 'writechar:');
	  writeln(Taus, chr(9), 'mov', chr(9), 'R2, R1');
	  writeln(Taus, chr(9), 'shr', chr(9), 'R2, #8');
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #1');
	  writeln(Taus, chr(9), 'mov', chr(9), AscReg, ', R2');
	  writeln(Taus, 'writechar_1:');
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #1');
	  Writeln(Taus, chr(9), 'jnb', chr(9), AscFlag, ', writechar_1');
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #1');
	  writeln(Taus, chr(9), 'bclr', chr(9), AscFlag);
	  
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #1');
	  writeln(Taus, chr(9), 'mov', chr(9), AscReg, ', R1');
	  writeln(Taus, 'writechar_2:');
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #1');
	  Writeln(Taus, chr(9), 'jnb', chr(9), AscFlag, ', writechar_2');
	  IF DPP[3] <> 3 THEN 
	    writeln(Taus, chr(9), 'extp', chr(9), '#3, #1');
	  writeln(Taus, chr(9), 'bclr', chr(9), AscFlag);
	  writeln(Taus, chr(9), 'ret', chr(9), chr(9), chr(9), '; writechar');
	  INC(cl, 228);
	END;
	

initialization

Nextstring := 0;
stringl := NIL;

end.